/*
Binary of Babel
Copyright (C) 2010 Segfault Garden

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef AUDIOMANAGER_H
#define AUDIOMANAGER_H

#include <stdint.h>
#include <gst/gst.h>


class AudioManager {
private:

    GstBus *bus;
    GstElement *pipeline;
    GstElement *source;
    bool hasAudioFile;

public:

    AudioManager();
    ~AudioManager();
    void loadFile(const char *fileName);
    void play();
    void stop();
    void pumpEvents();
    uint32_t getTime();
};

#endif
