/*
Binary of Babel
Copyright (C) 2010 Segfault Garden

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdarg.h>
#include <stdio.h>
#include "demolib.h"

#define BUF_SIZE 1024

static logLevel outputLevel = messageLevel;

void log_print(enum logLevel level, const char *fmt, ...) {
    va_list ap;
    char txt[BUF_SIZE];
    FILE *out;

    if (level < outputLevel)
        return;

    va_start(ap, fmt);
    int nchars = vsnprintf(txt, BUF_SIZE, fmt, ap);
    va_end(ap);

    if (level == errorLevel)
        out = stderr;
    else
        out = stdout;
    fprintf(out, "%s", txt);
}

void set_logging_level(enum logLevel newLevel) {
    outputLevel = newLevel;
}
