      *Binary of Babel
      *Copyright (C) 2010 Segfault Garden
      *
      *This program is free software: you can redistribute it and/or modify
      *it under the terms of the GNU General Public License as published by
      *the Free Software Foundation, either version 3 of the License, or
      *(at your option) any later version.
      *
      *This program is distributed in the hope that it will be useful,
      *but WITHOUT ANY WARRANTY; without even the implied warranty of
      *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
      *GNU General Public License for more details.
      *
      *You should have received a copy of the GNU General Public License
      *along with this program.  If not, see <http://www.gnu.org/licenses/>.

       IDENTIFICATION DIVISION.
       PROGRAM-ID. cobplug.

       ENVIRONMENT DIVISION.

       DATA DIVISION.
       WORKING-STORAGE SECTION.
       01 DS USAGE FLOAT-LONG VALUE 1.0.
       01 SHIFTX USAGE FLOAT-LONG VALUE 0.0.
       01 SHIFTY USAGE FLOAT-LONG VALUE 0.0.
       01 SHIFTZ USAGE FLOAT-LONG VALUE 0.0.
       01 Y USAGE FLOAT-LONG.
       01 PI USAGE FLOAT-LONG VALUE 3.14159.
       01 RADIUS USAGE FLOAT-LONG VALUE 1.5.
       01 THETA USAGE FLOAT-LONG.
       01 COSTHETA USAGE FLOAT-LONG.
       01 SINTHETA USAGE FLOAT-LONG.
       01 TX USAGE FLOAT-LONG.
       01 TY USAGE FLOAT-LONG.
       01 TZ USAGE FLOAT-LONG.
       LINKAGE SECTION.
       01 X USAGE FLOAT-LONG.
       01 Z USAGE FLOAT-LONG.
       01 T USAGE FLOAT-LONG.
       01 SCREENX USAGE FLOAT-LONG.
       01 SCREENY USAGE FLOAT-LONG.

       PROCEDURE DIVISION USING X Z T SCREENX SCREENY.
           COMPUTE THETA = T * 2.
	   COMPUTE Y = FUNCTION SIN(PI*(0.5*X + T*1.5 + 0.7*Z)).
	   SUBTRACT 1.0 FROM Y.
	   MULTIPLY 0.5 BY Y.
	   COMPUTE SHIFTX = FUNCTION SIN(PI*0.4*T) * RADIUS.
	   COMPUTE SHIFTY = FUNCTION COS(PI*0.6*T) * RADIUS * 0.5 - 0.5.
	   COMPUTE SHIFTZ = FUNCTION COS(PI*0.4*T) * RADIUS - 5.0.
	   COMPUTE COSTHETA = FUNCTION COS(THETA).
	   COMPUTE SINTHETA = FUNCTION SIN(THETA).
	   COMPUTE TX = X*COSTHETA + Z*SINTHETA.
	   MOVE Y TO TY.
	   COMPUTE TZ = -X*SINTHETA + Z*COSTHETA.
	   SUBTRACT SHIFTX FROM TX.
	   SUBTRACT SHIFTY FROM TY.
	   SUBTRACT SHIFTZ FROM TZ.
	   COMPUTE SCREENX = TX*DS/TZ.
	   COMPUTE SCREENY = TY*DS/TZ.
           EXIT PROGRAM.
