/*
Binary of Babel
Copyright (C) 2010 Segfault Garden

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#import <math.h>
#import "pluginapi.h"
#import "Roto.h"
#import "SDL.h"
#import "SDL_image.h"
#import <assert.h>

SDL_Surface *backImage;

Roto *r;

void init(int width, int height, const char *config_file) {
    r = [[Roto alloc] init];
    backImage = IMG_Load(config_file);
    assert(backImage != NULL);
    assert(backImage->pitch == 4*backImage->w);
    assert(backImage->w = width);
    assert(backImage->h = height);
    [r setW:width andH:height andP:backImage->pixels];
}

void render(unsigned char *texture, uint32_t time_in_milliseconds) {
    double zoom = (1.1 + sin(time_in_milliseconds/5000.0)*2.0*M_PI);
    double angle = time_in_milliseconds/4000.0*M_PI*2.0;
    int xoff = (time_in_milliseconds/100) % backImage->w;
    int yoff = (time_in_milliseconds/400) % backImage->h;
    [r setSrcXOff:xoff andYOff:yoff];
    [r rotate:angle andZoom:zoom andDst:texture];
}

void gc(void) {
}

void shutdown(void) {
    [r free];
    r = NULL;
    SDL_FreeSurface(backImage);
    backImage = NULL;
}
