/*
Binary of Babel
Copyright (C) 2010 Segfault Garden

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <assert.h>
#include "SDL.h"
#include "SDL_image.h"
#include "pluginapi.h"
#include "altdemo.h"

AltDemo *a;
int w, h;
SDL_Surface *landscape;

static void clearTexture(unsigned char *tex) {
    int i, j;

    for (j=0; j<h; j++) {
        for (i=0; i<w; i++) {
            unsigned char *base = tex + 4*(j*w + i);
            base[0] = 0;
            base[1] = 0;
            base[2] = 0;
        }
    }
}

void init(int width, int height, const char *config_file) {
    g_type_init();
    w = width;
    h = height;
    landscape = IMG_Load(config_file);
    if (!landscape) {
        printf("Image load is fail\n");
        exit(1);
    }
    assert(landscape->pitch == landscape->w);

    a = alt_demo_new(width, height);
    alt_demo_setLandscape(a, landscape->w, landscape->h, landscape->pixels);
}

void render(unsigned char *texture, uint32_t time_in_milliseconds) {
    clearTexture(texture);
    alt_demo_render(a, texture, time_in_milliseconds);
}

void gc(void) {

}

void shutdown(void) {
    SDL_FreeSurface(landscape);
}
